using System;
using System.Reflection;
using Object = System.Object;

namespace UModTld
{
    public static class Api
    {
        #region ReflectionApi
        internal static class ReflectionApi
        {
            #region Fields
            private static Type _cachedUModTldApi;
            #endregion
            #region GetUModTldApi
            public static Type GetUModTldApi()
            {
                if (_cachedUModTldApi != null)
                    return _cachedUModTldApi;
                foreach (var c in AppDomain.CurrentDomain.GetAssemblies())
                {
                    foreach (var t in c.GetTypes())
                    {
                        if (t.Name != "UModTldApi")
                            continue;
                        _cachedUModTldApi = t;
                        return _cachedUModTldApi;
                    }
                }
                return null;
            }
            #endregion
            #region InvokePublicStaticMethod
            public static Object InvokePublicStaticMethod(Type inst, String name, params Object[] arguments)
            {
                var dynMethod = inst.GetMethod(name, BindingFlags.Public | BindingFlags.Static);
                if (dynMethod != null)
                    return dynMethod.Invoke(inst, arguments);
                return null;
            }
            #endregion
        }
        #endregion
        #region AddConsoleCommand
        public static Boolean AddConsoleCommand(String name, String description, Func<String[], String> func)
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return false;
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "AddConsoleCommand", name, description, func);
            return ret is Boolean && (Boolean)ret;
        }
        #endregion
        #region DelConsoleCommand
        public static Boolean DelConsoleCommand(String name)
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return false;
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "DelConsoleCommand", name);
            return ret is Boolean && (Boolean)ret;
        }
        #endregion
        #region ConsoleCommandExists
        public static Boolean ConsoleCommandExists(String name)
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return false;
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "ConsoleCommandExists", name);
            return ret is Boolean && (Boolean)ret;
        }
        #endregion
        #region GetConsoleCommandDesc
        public static String GetConsoleCommandDesc(String name)
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return "";
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "GetConsoleCommandDesc", name);
            return ret is String ? (String)ret : "";
        }
        #endregion
        #region GetConsoleCommandCallback
        public static Object GetConsoleCommandCallback(String name)
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return null;
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "GetConsoleCommandCallback", name);
            return ret;
        }
        #endregion
        #region GetConsoleCommandList
        public static String[] GetConsoleCommandList(String rxPattern = "")
        {
            var t = ReflectionApi.GetUModTldApi();
            if (t == null)
                return new String[0];
            var ret = ReflectionApi.InvokePublicStaticMethod(t, "GetConsoleCommandList", rxPattern);
            return ret is String[] ? (String[])ret : new String[0];
        }
        #endregion
    }
}
